;*************************************************************************
;									 *
;*				ATMEGA Bootloader			 *
;*									 *
;*************************************************************************
.nolist
.include"m8def.inc"
.include"bootload.h"
.list
;
;.equ	signature	= 0x1E9403	;Mega16
;.equ	signature	= 0x1E9404	;Mega162
.equ	signature	= 0x1E9307	;Mega8
;
.equ	base	= THIRDBOOTSTART
;.equ	base	= SECONDBOOTSTART	;to small
;.equ	base	= 0
	.org	base
	rjmp	init
	.org	base + OVF1addr
	rjmp	OVF1int
	.org	base + URXCaddr
	rjmp	URXCint
	.org	base + NOINTaddr	;end of interrupt vector table
init:
	ldi		r16,	0xff
	out		PORTD,	r16
  schleife:
	dec		r16
	brne	schleife
	in		r16,	PIND
	andi	r16,	0x7c
	cpi		r16,	0x7c
	brne	bootldr
	rjmp	0x0000
  bootldr:
.include"init.inc"
;
;------------------------------------------------------------------------
	rcall	abaud			;detect baud rate
	rcall	set_baud		;set baud rate

;	ldi		r16,	'A'
;	out		UDR,	r16
main:	cbr	flags, 1<<f_error^1<<f_verify^1<<f_write
	rcall	rx_command		;Command received ?
	brcc	main
	rcall	exec_command		;Command execute
	ldi	a0, key_failed		;execution failed
	sbrs	flags, f_error		;test
	ldi	a0, key_done		;execution successful
	sbrc	flags, f_enable
	rcall	putchar			;send command execution status
	rjmp	main
;-------------------------------------------------------------------------
.include"uart.inc"
.include"commexec.inc"
.include"asc2hex.inc"
.include"commands.inc"
.include"hexout.inc"
.include"readcrc.inc"
.include"readsig.inc"
;.include"read.inc"
.include"userprog.inc"
.include"abaud.inc"
.list
.include"program.inc"
;-------------------------------------------------------------------------
